import _Promise from "@babel/runtime-corejs2/core-js/promise";
import _regeneratorRuntime from "@babel/runtime-corejs2/regenerator";
import { createBEM } from '../utils/create/bem';
import config from '../config';
import AMapJSAPILoader from '../utils/loader/amap-jsapi-loader';
import AMapUILoader from '../utils/loader/amap-ui-loader';
var bem = createBEM('am-map');
export default {
  name: 'AmMap',
  props: {
    getContainer: {
      type: [String, Function]
    },
    initMapOptions: {
      type: Object,
      deafult: function deafult() {
        return {};
      }
    }
  },
  provide: function provide() {
    return {
      $maproot: this
    };
  },
  data: function data() {
    return {
      config: config(),
      isShowDefaultContainer: true,
      map: null
    };
  },
  computed: {
    __mapComponent: function __mapComponent() {
      return !0;
    }
  },
  created: function created() {
    this.initStatus = null;
    this.readyHooks = [];
    this.errorHooks = [];
    this.isShowDefaultContainer = !this.getContainer;
    this.initStatus = this.init();
  },
  mounted: function mounted() {// this.injectHook();
  },
  beforeDestroy: function beforeDestroy() {
    this.initStatus = null;
  },
  methods: {
    createMap: function createMap() {
      var container = null;

      if (this.isShowDefaultContainer) {
        container = this.$refs.container;
      } else {
        container = typeof this.getContainer === 'function' ? this.getContainer() : document.querySelector(this.getContainer);
      }

      container.classList.add(bem('container'));
      this.map = new this.AMap.Map(container, this.initMapOptions);
    },
    injectHook: function injectHook() {
      while (this.readyHooks.length) {
        var hook = this.readyHooks.shift();
        this.ready(hook);
      }

      while (this.errorHooks.length) {
        var _hook = this.errorHooks.shift();

        this.error(_hook);
      }
    },
    ready: function ready(cb) {
      this.initStatus === null ? this.readyHooks.push(cb) : this.initStatus.then(cb);
    },
    error: function error(cb) {
      this.initStatus === null ? this.errorHooks.push(cb) : this.initStatus.catch(cb);
    },
    installAPI: function installAPI() {
      var AMap, initAMapUI, AMapUI;
      return _regeneratorRuntime.async(function installAPI$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _regeneratorRuntime.awrap(AMapJSAPILoader(this.config.AMap));

            case 2:
              AMap = _context.sent;
              this.AMap = AMap;

              if (!this.config.AMapUI) {
                _context.next = 10;
                break;
              }

              _context.next = 7;
              return _regeneratorRuntime.awrap(AMapUILoader(this.config.AMapUI));

            case 7:
              initAMapUI = _context.sent;
              AMapUI = initAMapUI();
              this.AMapUI = AMapUI;

            case 10:
              return _context.abrupt("return");

            case 11:
            case "end":
              return _context.stop();
          }
        }
      }, null, this);
    },
    init: function init() {
      var _this = this;

      return new _Promise(function _callee(ready, error) {
        return _regeneratorRuntime.async(function _callee$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                _context2.next = 3;
                return _regeneratorRuntime.awrap(_this.installAPI());

              case 3:
                if (!(_this.initStatus === null)) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt("return");

              case 5:
                _this.createMap();

                ready(_this);
                _context2.next = 12;
                break;

              case 9:
                _context2.prev = 9;
                _context2.t0 = _context2["catch"](0);
                error(_context2.t0);

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, null, null, [[0, 9]]);
      });
    }
  },
  render: function render() {
    var h = arguments[0];
    return h("div", {
      "class": bem()
    }, [this.isShowDefaultContainer ? h("div", {
      "ref": "container",
      "class": bem('container')
    }) : '', this.$slots.default]);
  }
};