"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs2/regenerator"));

var _bem = require("../utils/create/bem");

var _config = _interopRequireDefault(require("../config"));

var _amapJsapiLoader = _interopRequireDefault(require("../utils/loader/amap-jsapi-loader"));

var _amapUiLoader = _interopRequireDefault(require("../utils/loader/amap-ui-loader"));

var bem = (0, _bem.createBEM)('am-map');
var _default = {
  name: 'AmMap',
  props: {
    getContainer: {
      type: [String, Function]
    },
    initMapOptions: {
      type: Object,
      deafult: function deafult() {
        return {};
      }
    }
  },
  provide: function provide() {
    return {
      $maproot: this
    };
  },
  data: function data() {
    return {
      config: (0, _config.default)(),
      isShowDefaultContainer: true,
      map: null
    };
  },
  computed: {
    __mapComponent: function __mapComponent() {
      return !0;
    }
  },
  created: function created() {
    this.initStatus = null;
    this.readyHooks = [];
    this.errorHooks = [];
    this.isShowDefaultContainer = !this.getContainer;
    this.initStatus = this.init();
  },
  mounted: function mounted() {// this.injectHook();
  },
  beforeDestroy: function beforeDestroy() {
    this.initStatus = null;
  },
  methods: {
    createMap: function createMap() {
      var container = null;

      if (this.isShowDefaultContainer) {
        container = this.$refs.container;
      } else {
        container = typeof this.getContainer === 'function' ? this.getContainer() : document.querySelector(this.getContainer);
      }

      container.classList.add(bem('container'));
      this.map = new this.AMap.Map(container, this.initMapOptions);
    },
    injectHook: function injectHook() {
      while (this.readyHooks.length) {
        var hook = this.readyHooks.shift();
        this.ready(hook);
      }

      while (this.errorHooks.length) {
        var _hook = this.errorHooks.shift();

        this.error(_hook);
      }
    },
    ready: function ready(cb) {
      this.initStatus === null ? this.readyHooks.push(cb) : this.initStatus.then(cb);
    },
    error: function error(cb) {
      this.initStatus === null ? this.errorHooks.push(cb) : this.initStatus.catch(cb);
    },
    installAPI: function installAPI() {
      var AMap, initAMapUI, AMapUI;
      return _regenerator.default.async(function installAPI$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _regenerator.default.awrap((0, _amapJsapiLoader.default)(this.config.AMap));

            case 2:
              AMap = _context.sent;
              this.AMap = AMap;

              if (!this.config.AMapUI) {
                _context.next = 10;
                break;
              }

              _context.next = 7;
              return _regenerator.default.awrap((0, _amapUiLoader.default)(this.config.AMapUI));

            case 7:
              initAMapUI = _context.sent;
              AMapUI = initAMapUI();
              this.AMapUI = AMapUI;

            case 10:
              return _context.abrupt("return");

            case 11:
            case "end":
              return _context.stop();
          }
        }
      }, null, this);
    },
    init: function init() {
      var _this = this;

      return new _promise.default(function _callee(ready, error) {
        return _regenerator.default.async(function _callee$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                _context2.next = 3;
                return _regenerator.default.awrap(_this.installAPI());

              case 3:
                if (!(_this.initStatus === null)) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt("return");

              case 5:
                _this.createMap();

                ready(_this);
                _context2.next = 12;
                break;

              case 9:
                _context2.prev = 9;
                _context2.t0 = _context2["catch"](0);
                error(_context2.t0);

              case 12:
              case "end":
                return _context2.stop();
            }
          }
        }, null, null, [[0, 9]]);
      });
    }
  },
  render: function render() {
    var h = arguments[0];
    return h("div", {
      "class": bem()
    }, [this.isShowDefaultContainer ? h("div", {
      "ref": "container",
      "class": bem('container')
    }) : '', this.$slots.default]);
  }
};
exports.default = _default;